Bug 551962 - dhclient -6 overwrites /etc/resolv.conf set up by NetworkManager
dhclient -6 overwrites /etc/resolv.conf set up by NetworkManager
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: dhcp (Show other bugs)
15
All Linux
low Severity medium
: ---
: ---
Assigned To: Jiri Popelka
Fedora Extras Quality Assurance
:
Depends On: 668153
Blocks: 654642
  Show dependency treegraph
 
Reported: 2010-01-03 06:38 EST by Frank Crawford
Modified: 2013-02-08 10:47 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 654642 (view as bug list)
Environment:
Last Closed: 2011-09-30 10:54:37 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Frank Crawford 2010-01-03 06:38:46 EST
Description of problem:

dhclient -6 (DHCP client for DHCPv6) overwrites setting in /etc/resolv.conf made by NetworkManager.

Version-Release number of selected component (if applicable):
dhclient-4.1.0p1-13.fc12.i686
NetworkManager-0.7.996-7.git20091113.fc12.i686

How reproducible:
100% of time.

Steps to Reproduce:
1. Connect to a network with NetworkManager supporting IPv4 and IPv6.
2. Invoke /sbin/dhclient -6 to obtain IPv6 not obtained by NetworkManager.
3.
  
Actual results:
Observe that in /etc/resolv.conf, the original information supplied by NetworkManager has been replaced by dhclient IPv6 information.  In particular all IPv4 addresses in nameserver lines have been replaced by IPv6 addresses.

Expected results:
Both IPv4 and IPv6 addresses should be available in /etc/resolv.conf.

Additional info:
This configuration is brought about by the fact that NetworkManager does not support the full RA option set, and in particular the "AdvManagedFlag on" setting.
Comment 1 Jiri Popelka 2010-04-12 10:11:08 EDT
Maybe interesting thread:
https://lists.isc.org/pipermail/dhcp-users/2010-April/011142.html
Comment 2 udo 2010-09-14 10:56:05 EDT
Currently I am hacking dhclient-script etc for ipv6 PD support etc, so I might take a look at this problem as well. See https://bugzilla.redhat.com/show_bug.cgi?id=626514 for the pd/radvd stuff.
Comment 3 udo 2010-09-14 11:18:33 EDT
Question: assuming we have the dns info from the dhcp server, plus also the local stuff that goes in resolv.conf, how would I combine that? I mean, in what order, what way?

# start local part
search bla.local
domain bla.local
server 127.0.0.1
# end local
# start dhcp part
search isp.com
server x.y.z.a
# end dhcp part

?
Comment 4 Bug Zapper 2011-06-02 13:00:46 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Jiri Popelka 2011-09-30 10:54:37 EDT
The solution to this problems would be in having a middleman which takes the nameserver information from each service (dhclient, NetworkManager, initscripts etc.) and merges them together to form one resolv.conf. The openresolv (bug #668153) program addresses this.

However this BZ has been quite invalid since NetworkManager supports IPv4 & IPv6 including responding to RA O & M bits (so there are actually no reasons now to run another dhclient because of IPv6).

It could also cause more pain (see bug #668153, comment #3 + bug #679445, comment #2) than gain (udo is the only person I know about who would benefit from this).

Closing as wontfix.
Comment 6 udo 2011-09-30 11:04:11 EDT
So what is the solution for this issue for PD users?
Prefix Delegation is the proper way to roll out IPv6.
So why ignore that market?

And why is NM doing whatever you describe? It doesn't even handle the most basic stuff, so why entrust it with stuff that belongs to another program?
NM does udev, does dhclient, what is next?

Note You need to log in before you can comment on or make changes to this bug.